// -*- C++ -*-
//
// FRModel.cc is a part of Herwig - A multi-purpose Monte Carlo event generator
// Copyright (C) 2002-2007 The Herwig Collaboration
//
// Herwig is licenced under version 2 of the GPL, see COPYING for details.
// Please respect the MCnet academic guidelines, see GUIDELINES for details.
//
//
// This is the implementation of the non-inlined, non-templated member
// functions of the FRModel class.
//

#include "FRModel.h"
#include "ThePEG/Interface/ClassDocumentation.h"
#include "ThePEG/Interface/Reference.h"
#include "ThePEG/Interface/Parameter.h"
#include "ThePEG/Persistency/PersistentOStream.h"
#include "ThePEG/Persistency/PersistentIStream.h"
#include "ThePEG/Helicity/Vertex/VertexBase.h"
#include "ThePEG/Utilities/DescribeClass.h"
#include <fstream>

//#include "Herwig/Models/General/ModelGenerator.h"

using namespace ThePEG;
using namespace Herwig;

FRModel::FRModel()
: ZERO_(),
gYXm_(1.0),gYq_(0.25),aEWM1_(127.9),Gf_(1.16637e-05),aS_(0.1184),
ymb_(4.7),ymt_(172),ymtau_(1.777),MZ_(),MTA_(),
MT_(),MB_(),MH_(),MXm_(),MY1_(),
WZ_(),WW_(),WT_(),WH_(),WXm_(),
WY1_(),aEW_(),G_(),MW_(),ee_(),
sw2_(),cw_(),sw_(),g1_(),gw_(),
vev_(),lam_(),yb_(),yt_(),ytau_(),
muH_(),I1a33_(0.0,0.0),I2a33_(0.0,0.0),I3a33_(0.0,0.0),I4a33_(0.0,0.0)

{}

IBPtr FRModel::clone() const {
  return new_ptr(*this);
}

IBPtr FRModel::fullclone() const {
  return new_ptr(*this);
}

void FRModel::doinit() {
     ZERO_ = 0.0;
   MZ_ = getParticleData(23)->mass()  / GeV;
   MTA_ = getParticleData(15)->mass()  / GeV;
   MT_ = getParticleData(6)->mass()  / GeV;
   MB_ = getParticleData(5)->mass()  / GeV;
   MH_ = getParticleData(25)->mass()  / GeV;
   MXm_ = getParticleData(52)->mass()  / GeV;
   MY1_ = getParticleData(9000006)->mass()  / GeV;
   WZ_ = getParticleData(23)->width() / GeV;
   WW_ = getParticleData(24)->width() / GeV;
   WT_ = getParticleData(6)->width() / GeV;
   WH_ = getParticleData(25)->width() / GeV;
   WXm_ = getParticleData(52)->width() / GeV;
   WY1_ = getParticleData(9000006)->width() / GeV;
   aEW_ = (1.0/aEWM1());
   G_ = ((2.0*sqrt(aS()))*sqrt(pi));
   MW_ = sqrt(((sqr(MZ())/2.0)+sqrt(((pow(MZ(),4.0)/4.0)-(((aEW()*pi)*sqr(MZ()))/(Gf()*sqrt(2.0)))))));
   resetMass(24,MW_ * GeV);
   ee_ = ((2.0*sqrt(aEW()))*sqrt(pi));
   sw2_ = (1.0-(sqr(MW())/sqr(MZ())));
   cw_ = sqrt((1.0-sw2()));
   sw_ = sqrt(sw2());
   g1_ = (ee()/cw());
   gw_ = (ee()/sw());
   vev_ = (((2.0*MW())*sw())/ee());
   lam_ = (sqr(MH())/(2.0*sqr(vev())));
   yb_ = ((ymb()*sqrt(2.0))/vev());
   yt_ = ((ymt()*sqrt(2.0))/vev());
   ytau_ = ((ymtau()*sqrt(2.0))/vev());
   muH_ = sqrt((lam()*sqr(vev())));
   I1a33_ = yb();
   I2a33_ = yt();
   I3a33_ = yt();
   I4a33_ = yb();
  BSMModel::doinit();
  
  writeParamCard();
}

void FRModel::doinitrun() {
  BSMModel::doinitrun();
  writeParamCard();
}

void FRModel::persistentOutput(PersistentOStream & os) const {
  os << ZERO_
<< gYXm_<< gYq_<< aEWM1_<< Gf_<< aS_
<< ymb_<< ymt_<< ymtau_<< MZ_<< MTA_
<< MT_<< MB_<< MH_<< MXm_<< MY1_
<< WZ_<< WW_<< WT_<< WH_<< WXm_
<< WY1_<< aEW_<< G_<< MW_<< ee_
<< sw2_<< cw_<< sw_<< g1_<< gw_
<< vev_<< lam_<< yb_<< yt_<< ytau_
<< muH_<< I1a33_<< I2a33_<< I3a33_<< I4a33_
 ;
}

void FRModel::persistentInput(PersistentIStream & is, int) {
  is >> ZERO_
>> gYXm_>> gYq_>> aEWM1_>> Gf_>> aS_
>> ymb_>> ymt_>> ymtau_>> MZ_>> MTA_
>> MT_>> MB_>> MH_>> MXm_>> MY1_
>> WZ_>> WW_>> WT_>> WH_>> WXm_
>> WY1_>> aEW_>> G_>> MW_>> ee_
>> sw2_>> cw_>> sw_>> g1_>> gw_
>> vev_>> lam_>> yb_>> yt_>> ytau_
>> muH_>> I1a33_>> I2a33_>> I3a33_>> I4a33_
 ;
}

void FRModel::writeParamCard() const {
  ofstream card("param_card.dat");

  card 
    << "#####################################################\n"
    << "## DO NOT EDIT - GENERATED BY HERWIG UFO CONVERTER ##\n"
    << "#####################################################\n\n";

  card 
    << "Block MASS\n"
<< "   23 " << MZ() << " # MZ\n"
<< "   15 " << MTA() << " # MTA\n"
<< "    6 " << MT() << " # MT\n"
<< "    5 " << MB() << " # MB\n"
<< "   25 " << MH() << " # MH\n"
<< "  9000005 " << MXm() << " # MXm\n"
<< "  9000006 " << MY1() << " # MY1\n"
<< "Block DMINPUTS\n"
<< "    1 " << gYXm() << " # gYXm\n"
<< "    2 " << gYq() << " # gYq\n"
<< "Block SMINPUTS\n"
<< "    1 " << aEWM1() << " # aEWM1\n"
<< "    2 " << Gf() << " # Gf\n"
<< "    3 " << aS() << " # aS\n"
<< "Block YUKAWA\n"
<< "    5 " << ymb() << " # ymb\n"
<< "    6 " << ymt() << " # ymt\n"
<< "   15 " << ymtau() << " # ymtau\n"
<< "DECAY  23 " << WZ() << "\n"
<< "DECAY  24 " << WW() << "\n"
<< "DECAY   6 " << WT() << "\n"
<< "DECAY  25 " << WH() << "\n"
<< "DECAY 9000005 " << WXm() << "\n"
<< "DECAY 9000006 " << WY1() << "\n"
    << '\n';

  card.close();
}

// Static variable needed for the type description system in ThePEG.
DescribeClass<FRModel,BSMModel>
  describeThePEGFRModel("Herwig::FRModel", "FRModel.so");

void FRModel::Init() {
  


static ClassDocumentation<FRModel> documentation
  ("The FRModel class inherits from BSMModel"
   "and supplies additional couplings and access to the FRModel"
   "vertices for helicity amplitude calculations" );

 static Parameter<FRModel, double> interfacegYXm
  ("gYXm",
   "The interface for parameter gYXm",
   &FRModel::gYXm_, 1.0, 0, 0,
   false, false, Interface::nolimits);
static Parameter<FRModel, double> interfacegYq
  ("gYq",
   "The interface for parameter gYq",
   &FRModel::gYq_, 0.25, 0, 0,
   false, false, Interface::nolimits);
static Parameter<FRModel, double> interfaceaEWM1
  ("aEWM1",
   "The interface for parameter aEWM1",
   &FRModel::aEWM1_, 127.9, 0, 0,
   false, false, Interface::nolimits);
static Parameter<FRModel, double> interfaceGf
  ("Gf",
   "The interface for parameter Gf",
   &FRModel::Gf_, 1.16637e-05, 0, 0,
   false, false, Interface::nolimits);
static Parameter<FRModel, double> interfaceaS
  ("aS",
   "The interface for parameter aS",
   &FRModel::aS_, 0.1184, 0, 0,
   false, false, Interface::nolimits);
static Parameter<FRModel, double> interfaceymb
  ("ymb",
   "The interface for parameter ymb",
   &FRModel::ymb_, 4.7, 0, 0,
   false, false, Interface::nolimits);
static Parameter<FRModel, double> interfaceymt
  ("ymt",
   "The interface for parameter ymt",
   &FRModel::ymt_, 172, 0, 0,
   false, false, Interface::nolimits);
static Parameter<FRModel, double> interfaceymtau
  ("ymtau",
   "The interface for parameter ymtau",
   &FRModel::ymtau_, 1.777, 0, 0,
   false, false, Interface::nolimits);

// no interface for MZ. Use particle definition instead.

// no interface for MTA. Use particle definition instead.

// no interface for MT. Use particle definition instead.

// no interface for MB. Use particle definition instead.

// no interface for MH. Use particle definition instead.

// no interface for MXm. Use particle definition instead.

// no interface for MY1. Use particle definition instead.

// no interface for WZ. Use particle definition instead.

// no interface for WW. Use particle definition instead.

// no interface for WT. Use particle definition instead.

// no interface for WH. Use particle definition instead.

// no interface for WXm. Use particle definition instead.

// no interface for WY1. Use particle definition instead.


}


